# coding: utf-8

"""
    Alfresco Content Services REST API

    **Core API**  Provides access to the core features of Alfresco Content Services.   # noqa: E501

    OpenAPI spec version: 1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from alfresco_core_api_client.configuration import Configuration


class NodeBodyUpdate(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'node_type': 'str',
        'aspect_names': 'list[str]',
        'properties': 'dict(str, str)',
        'permissions': 'PermissionsBody'
    }

    attribute_map = {
        'name': 'name',
        'node_type': 'nodeType',
        'aspect_names': 'aspectNames',
        'properties': 'properties',
        'permissions': 'permissions'
    }

    def __init__(self, name=None, node_type=None, aspect_names=None, properties=None, permissions=None, _configuration=None):  # noqa: E501
        """NodeBodyUpdate - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._name = None
        self._node_type = None
        self._aspect_names = None
        self._properties = None
        self._permissions = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if node_type is not None:
            self.node_type = node_type
        if aspect_names is not None:
            self.aspect_names = aspect_names
        if properties is not None:
            self.properties = properties
        if permissions is not None:
            self.permissions = permissions

    @property
    def name(self):
        """Gets the name of this NodeBodyUpdate.  # noqa: E501

        The name must not contain spaces or the following special characters: * \" < > \\ / ? : and |. The character . must not be used at the end of the name.   # noqa: E501

        :return: The name of this NodeBodyUpdate.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this NodeBodyUpdate.

        The name must not contain spaces or the following special characters: * \" < > \\ / ? : and |. The character . must not be used at the end of the name.   # noqa: E501

        :param name: The name of this NodeBodyUpdate.  # noqa: E501
        :type: str
        """
        if (self._configuration.client_side_validation and
                name is not None and not re.search(r'^(?!(.*[\\\"\\*\\\\\\>\\<\\?\/\\:\\|]+.*)|(.*[\\.]?.*[\\.]+$)|(.*[ ]+$))', name)):  # noqa: E501
            raise ValueError(r"Invalid value for `name`, must be a follow pattern or equal to `/^(?!(.*[\\\"\\*\\\\\\>\\<\\?\/\\:\\|]+.*)|(.*[\\.]?.*[\\.]+$)|(.*[ ]+$))/`")  # noqa: E501

        self._name = name

    @property
    def node_type(self):
        """Gets the node_type of this NodeBodyUpdate.  # noqa: E501


        :return: The node_type of this NodeBodyUpdate.  # noqa: E501
        :rtype: str
        """
        return self._node_type

    @node_type.setter
    def node_type(self, node_type):
        """Sets the node_type of this NodeBodyUpdate.


        :param node_type: The node_type of this NodeBodyUpdate.  # noqa: E501
        :type: str
        """

        self._node_type = node_type

    @property
    def aspect_names(self):
        """Gets the aspect_names of this NodeBodyUpdate.  # noqa: E501


        :return: The aspect_names of this NodeBodyUpdate.  # noqa: E501
        :rtype: list[str]
        """
        return self._aspect_names

    @aspect_names.setter
    def aspect_names(self, aspect_names):
        """Sets the aspect_names of this NodeBodyUpdate.


        :param aspect_names: The aspect_names of this NodeBodyUpdate.  # noqa: E501
        :type: list[str]
        """

        self._aspect_names = aspect_names

    @property
    def properties(self):
        """Gets the properties of this NodeBodyUpdate.  # noqa: E501


        :return: The properties of this NodeBodyUpdate.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this NodeBodyUpdate.


        :param properties: The properties of this NodeBodyUpdate.  # noqa: E501
        :type: dict(str, str)
        """

        self._properties = properties

    @property
    def permissions(self):
        """Gets the permissions of this NodeBodyUpdate.  # noqa: E501


        :return: The permissions of this NodeBodyUpdate.  # noqa: E501
        :rtype: PermissionsBody
        """
        return self._permissions

    @permissions.setter
    def permissions(self, permissions):
        """Sets the permissions of this NodeBodyUpdate.


        :param permissions: The permissions of this NodeBodyUpdate.  # noqa: E501
        :type: PermissionsBody
        """

        self._permissions = permissions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NodeBodyUpdate, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NodeBodyUpdate):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, NodeBodyUpdate):
            return True

        return self.to_dict() != other.to_dict()
